 #include <windows.h>
 #include <iostream.h>
 #include <stdio.h>
 #include <conio.h>

 #define MAXMODULE 150
 #define NOTECHS 9
 typedef int (WINAPI*sfunc)(int[NOTECHS]);
 typedef int (WINAPI*cfunc)(int[9][9],int,int,int,int,int);
 typedef int (WINAPI*bfunc)(int[16][16],int,int,int,int,int);

 sfunc SetTechs;
 cfunc Generate9;
 bfunc Generate16;

 int techs[NOTECHS];
 int dim = 9;
 int diff = 3;
 int diffMin = 22;
 int diffMax = 32;
 int minMax[4][2] = {{25,35},{22,32},{16,30},{16,30}};
 int diagMinMax[4][2] = {{21,28},{19,24},{14,25},{14,25}};
 int diagonalVers = 0;
 int symmetric = 0;
 int partGrid[9][9];
 int bigGrid[16][16];
 int success;
 char L[99]=".123456789ABCDEFG";
 HINSTANCE hLib;

 /*
 Generate(int partGrid[9][9],
  int diff, int diffMin, int diffMax, int diagonalVers, int symmetric);
 */
 /* Generate generates a Sudoku grid, partGrid[9][9], 1st index column, 2nd index row. Not givens set to 0.
Difficulty level  diff set to 1,2,3 or 4, see User's Guide. The minimum and maximum number of givens that
Generate must keep within, are defined by diffMin and diffMax.
If symmetric is set to TRUE, a symmetric puzzle is generated, if set to FALSE an asymmetric
puzzle is generated. For symmetric puzzles, the parameters diffMin and diffMax are not used, puzzles are
generated with a maximum of 31 given digits.  Generated asymmetric puzzles are always minimal, this is not
the case for symmetric puzzles. 
If diagonalVers is TRUE, the diagonal Sudoku-variant applies, see User's Guide.
Generate  returns 1 (=success), except if technic configuration has left this difficulty level (diff) without technics. Further explanation, see description of SetLevels function. In such a case, Generate returns 0.
Advice for setting diffMin and diffMax:
The following values will give good performance (other values are of course also possible):
For difficulty level "easy":  
Normal Sudoku: diffMin=25, diffMax=35    Diagonal version: diffMin=21, diffMax=28
For difficulty level "medium":  
Normal Sudoku: diffMin=22, diffMax=32    Diagonal version: diffMin=19, diffMax=24
For difficulty levels "hard and fiendish":  
Normal Sudoku: diffMin=16, diffMax=30    Diagonal version: diffMin=14, diffMax=25
 */
/*
 stdcall Generate(int partGrid[16][16],
  int diff, int diffMin, int diffMax, int variant, int symmetric);
*/
/* Generate generates a Sudoku grid, partGrid[16][16], 1st index column (0..15), 2nd index row (0..15). Not givens set to 0. Difficulty level  diff set to 1,2,3 or 4, see User's Guide. The diffMin and diffMax parameters are not used.
Generated puzzles are asymmetric and minimal. The parameters variant and symmetric are not presently used and set to 0.
Generate  returns 1 (=success), except if technic configuration has left this difficulty level (diff) without technics. Further explanation, see description of SetLevels function. In such a case, Generate returns 0.
 */

/* SetLevels (int levels[NOTECHS);

SetLevels allows the GUI frontend, within some restrictions, to configure which technics that are allocated to a particular difficulty level. Without any configuration by SetLevels, the engine sets up a default configuration, see User's Guide. E.g. the X-wings technique is then allocated to difficulty level 3.
By defining that a certain technique applies to certain difficulty level is meant that the solution of the grid require usage of this or another technique specified for this difficulty level. For a lower difficulty level, the technique is not required to solve the grid.
The following configuration possibilities apply:
Single candidate:		Required difficulty level is always 1 (lowest level), i.e not configurable.
Unique candidate:		Same as for Single candidate.
Pairs/triplets:			Can be disconnected (0) or allocated to any level 1, 2 or 3.
Block/column/row interaction:	Same as for Pairs/triplets.
Block/block interaction:		Same as for Pairs/triplets.
Hidden pairs:			Same as for Pairs/triplets.
Hidden triplets:			Same as for Pairs/triplets.
X-wings:			Same as for Pairs/triplets.
Guessing			Required difficulty level is always 4 (highest level), i.e not configurable.

Calling SetLevels is not necessary to achieve the default configuration, the engine (DLL) sets automatically up the default configuration at its start-up.

The GUI frontend provides the configuration information by setting the array levels[NOTECHS] as follows:
levels[Index]=Difficulty level,  where 0 means that the technic is disconnected.

Index=0		Single candidate                             1
Index=1		Unique candidate                             1
Index=2		Pairs/triplets                               2
Index=3		Block/column/row interaction                 2
Index=4		Block/block interaction                      2
Index=5		Hidden pairs                                 3
Index=6		Hidden triplets                              3
Index=7		X-wings                                      3
Index=8		Guessing                                     4

SetLevels returns TRUE if the configuration succeeds. If the configuration settings are out of scope, SetLevels returns -1  without effectuating any configuration change.

The GUI frontend should check that at least 1 technic has been allocated to the present difficulty level before calling Solve or Generate. */

/* "sudgen.exe 9 4 1 1 3 2 2 3 3 3 4" */

int main(int argc, char *argv[]){
    if(argc <= 2){
       goto badexit;
    }

    sscanf(argv[1],"%i", &dim);
         if (dim != 9 && dim != 16){
            cout << "Dim must be 9 or 16" << endl;
            return 0;
         }
     sscanf(argv[2],"%i",&diff);
     if (diff < 1 || diff > 4){
       cout << "Difficulty level must be between 1 and 4" << endl;
       return 0;
     }

     if(argc > 3){
       if(argc < 12){
         goto badexit;
       }
       for(int x=3; x<argc; x++){
         if (x > NOTECHS+3){
            cout << "x=" << x << endl;
            goto badexit;
         }
         sscanf(argv[x],"%i", &techs[x-3]);
         if (techs[x-3] < 0 || techs[x-3] > 4){
            cout << "tech=" << techs[x-3] << endl;
            goto badexit;
         }
       }
     }


    if(dim == 9){
        hLib=LoadLibrary("suo_111_eng.dll");
        if(hLib==NULL) {
           cout << "Unable to load library!" << endl;
           return 0;
        }

        char mod[MAXMODULE];
        GetModuleFileName((HMODULE)hLib, (LPTSTR)mod, MAXMODULE);
        if (argc > 3){
           SetTechs=(sfunc)GetProcAddress((HMODULE)hLib, "SetLevels");
           if(SetTechs==NULL) {
             cout << "Unable to load 'Set Levels'." << endl;
           }
           success = (SetTechs)(techs);
        }
        Generate9=(cfunc)GetProcAddress((HMODULE)hLib, "Generate");
        if(Generate9==NULL) {
            cout << "Unable to load 'Generate'." << endl;
            FreeLibrary((HMODULE)hLib);
            return 0;
        }
        success = (Generate9)(partGrid, diff, diffMin, diffMax, diagonalVers, symmetric);
        if (success == 1){
           for (int i=0; i<dim; i++){
               for (int j=0; j<dim; j++){
                   cout << L[partGrid[i][j]];
               }
           }
        }
        FreeLibrary((HMODULE)hLib);
        return 0;

    } else {
        hLib=LoadLibrary("s16_051.dll");
        if(hLib==NULL) {
           cout << "Unable to load library!" << endl;
           return 0;
        }

        char mod[MAXMODULE];
        GetModuleFileName((HMODULE)hLib, (LPTSTR)mod, MAXMODULE);
        if (argc > 3){
           SetTechs=(sfunc)GetProcAddress((HMODULE)hLib, "SetLevels");
           if(SetTechs==NULL) {
             cout << "Unable to load 'Set Levels'." << endl;
           }
           success = (SetTechs)(techs);
        }
        Generate16=(bfunc)GetProcAddress((HMODULE)hLib, "Generate");
        if(Generate16==NULL) {
            cout << "Unable to load function(s)." << endl;
            FreeLibrary((HMODULE)hLib);
            return 0;
        }
        success = (Generate16)(bigGrid, diff, 0, 0, 0, 0);
     if (success == 1){
     for (int i=0; i<dim; i++){
           for (int j=0; j<dim; j++){
               cout << L[bigGrid[i][j]];
           }
       }
     }
     FreeLibrary((HMODULE)hLib);
     return 0;
   }

   badexit:
      cout << "argc: " << argc << endl;
      cout << endl << "Usage: sudgen dim difficulty [single unique pairs brc bb hp ht xwing guess]" << endl;
      cout << "where dim is either 9 or 16, representing the dimensions of the puzzle;" << endl;
      cout << "difficulty = 1,2,3, or 4;" << endl;
      cout << "and all other parameters are integers 0 - 4 representing the difficulty level" << endl;
      cout << "for each technique. single: Single Candidate, unique: Unique candidate," << endl;
      cout << " pairs: Pairs/triplets, brc: Block/row/column interaction," << endl;
      cout << " bb: Block/block interaction, hp: Hidden pairs, ht: Hidden triplets," << endl;
      cout << " xwing: X-wing, guess: Guessing" << endl;
      return 0;

}
